import { EventEmitter } from "@angular/core";
import { ControlValueAccessor } from "@angular/forms";
/**
 * **Ignite UI for Angular Switch** -
 * [Documentation](https://www.infragistics.com/products/ignite-ui-angular/angular/components/switch.html)
 *
 * The Ignite UI Switch lets the user toggle between on/off or true/false states.
 *
 * Example:
 * ```html
 * <igx-switch checked="true">
 *   Simple switch
 * </igx-switch>
 * ```
 */
export declare class IgxSwitchComponent implements ControlValueAccessor {
    value: any;
    id: string;
    readonly labelId: string;
    name: string;
    disabled: boolean;
    tabindex: number;
    checked: boolean;
    change: EventEmitter<Event>;
    nativeCheckbox: any;
    focused: boolean;
    protected _value: any;
    private _onTouchedCallback;
    private _onChangeCallback;
    onChange(event: any): void;
    onFocus(event: any): void;
    onBlur(event: any): void;
    writeValue(value: any): void;
    registerOnChange(fn: (_: any) => void): void;
    registerOnTouched(fn: () => void): void;
}
export declare class IgxSwitchModule {
}
